Bug 892808 - [FEAT] Bring subdirectory mount option with native client
[FEAT] Bring subdirectory mount option with native client
Status: POST
Product: GlusterFS
Classification: Community
Component: fuse (Show other bugs)
mainline
x86_64 Linux
low Severity low
: ---
: ---
Assigned To: Pranith Kumar K
: FutureFeature, Reopened
Depends On:
Blocks: 1286783 1021412 1286784
  Show dependency treegraph
 
Reported: 2013-01-07 16:50 EST by rob
Modified: 2017-01-17 08:53 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
: 1021412 (view as bug list)
Environment:
Last Closed: 2015-10-22 11:46:38 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description rob 2013-01-07 16:50:41 EST
Description of problem:
When mounting a volume with the native client, you cannot specify a subdirectory. 

Version-Release number of selected component (if applicable):
3.3.0

How reproducible:
Every time

Steps to Reproduce:
1. mount -t glusterfs <glusterhost>:/<volume>/<path>
2.
3.
  
Actual results:
Logs below

Expected results:
Mounting a path should work similar to an nfs mount. 


Additional info:

[2013-01-07 16:44:03.565471] I [glusterfsd.c:1666:main] 0-/usr/sbin/glusterfs: Started running /usr/sbin/glusterfs version 3.3.1
[2013-01-07 16:44:03.598470] E [glusterfsd-mgmt.c:1559:mgmt_getspec_cbk] 0-glusterfs: failed to get the 'volume file' from server
[2013-01-07 16:44:03.598584] E [glusterfsd-mgmt.c:1627:mgmt_getspec_cbk] 0-mgmt: failed to fetch volume file (key:/exporter/exporter)
[2013-01-07 16:44:03.598926] W [glusterfsd.c:831:cleanup_and_exit] (-->/usr/lib64/libgfrpc.so.0(rpc_clnt_notify+0x120) [0x32e0e0f8b0] (-->/usr/lib64/libgfrpc.so.0(rpc_clnt_handle_reply+0xa5) [0x32e0e0f0b5] (-->/usr/sbin/glusterfs(mgmt_getspec_cbk+0x292) [0x40c9d2]))) 0-: received signum (0), shutting down
[2013-01-07 16:44:03.598975] I [fuse-bridge.c:4648:fini] 0-fuse: Unmounting '/appdata/exporter'.

In this case the volume is called "exporter". I was trying to create directories underneath to have separate paths on different servers so the whole volume wasn't mounted on every server. If I could mount different paths I can have a centralized and shared gluster implementation that I can scale centrally. Additional gluster systems and/or additional bricks/volumes adds a bunch more effort.

In the mean time, im going to create separate LVM based bricks and on top of those create separate volumes. This way I can scale up volumes separately.
Comment 2 Amar Tumballi 2013-02-20 01:34:53 EST
this is known issue as of now, and
Comment 7 Niels de Vos 2015-04-14 00:38:59 EDT
http://review.gluster.org/10186 has been posted for review.
Comment 8 Anand Avati 2015-04-15 01:09:38 EDT
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#3) for review on master by Anand Avati (avati@redhat.com)
Comment 9 Anand Avati 2015-05-20 14:33:49 EDT
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#4) for review on master by Anand Avati (avati@redhat.com)
Comment 10 Anand Avati 2015-05-27 06:10:08 EDT
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#5) for review on master by Kaleb KEITHLEY (kkeithle@redhat.com)
Comment 11 Anand Avati 2015-07-29 06:47:00 EDT
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#6) for review on master by Raghavendra G (rgowdapp@redhat.com)
Comment 13 Kaleb KEITHLEY 2015-10-22 11:46:38 EDT
because of the large number of bugs filed against mainline version\ is ambiguous and about to be removed as a choice.

If you believe this is still a bug, please change the status back to NEW and choose the appropriate, applicable version for it.
Comment 14 Vijay Bellur 2015-12-21 16:48:50 EST
As we are looking to add this support in 3.8, moving the status of this bugzilla to open.
Comment 15 Vijay Bellur 2015-12-28 05:11:16 EST
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#7) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 16 Vijay Bellur 2015-12-28 06:01:17 EST
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#8) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 17 Vijay Bellur 2015-12-29 01:40:43 EST
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#9) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 18 Vijay Bellur 2016-02-09 04:37:53 EST
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#10) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 19 Vijay Bellur 2016-02-09 04:37:59 EST
REVIEW: http://review.gluster.org/13404 (mount/fuse: Return correct errno for resolution failures) posted (#1) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 20 Vijay Bellur 2016-02-10 04:03:26 EST
REVIEW: http://review.gluster.org/13404 (mount/fuse: Return correct errno for resolution failures) posted (#2) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 21 Vijay Bellur 2016-02-10 04:03:32 EST
REVIEW: http://review.gluster.org/10186 (fuse: support subdirectory mounts) posted (#11) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)
Comment 22 Vijay Bellur 2016-03-09 21:14:59 EST
REVIEW: http://review.gluster.org/13659 (protocol/server (mostly): add subdirectory mounting support) posted (#1) for review on master by Jeff Darcy (jdarcy@redhat.com)
Comment 23 Vijay Bellur 2016-03-10 09:15:28 EST
REVIEW: http://review.gluster.org/13659 (protocol/server (mostly): add subdirectory mounting support) posted (#2) for review on master by Jeff Darcy (jdarcy@redhat.com)
Comment 24 Vijay Bellur 2016-03-10 09:35:20 EST
REVIEW: http://review.gluster.org/13659 (protocol/server (mostly): add subdirectory mounting support) posted (#3) for review on master by Jeff Darcy (jdarcy@redhat.com)
Comment 25 Mike McCune 2016-03-28 19:18:47 EDT
This bug was accidentally moved from POST to MODIFIED via an error in automation, please see mmccune@redhat.com with any questions
Comment 26 Niels de Vos 2016-05-10 05:37:56 EDT
This didnt make it for GlusterFS 3.8, moving out of the tracking tree.
Comment 28 Bipin Kunal 2016-08-30 08:56:51 EDT
Pranith : As we targetting this for 3.9 ? What is the current progress ? I don't see activity from long time. Do we have something going on parallely in different bug?
Comment 29 Pranith Kumar K 2016-08-30 10:54:04 EDT
hi Bipin,
    We had two solutions:
1) http://review.gluster.org/10186 but the solution proved to be dead-end.
2) http://review.gluster.org/13659 this solution also proved to be a dead-end because existing locks feature won't work with this approach.

Jeff, Shyam, Vijay and I just finalized on an approach we all liked just 2 weeks back, but this is not going to make it for 3.9.0 I will be sending the first cut of the design this week on gluster-devel

Pranith
Comment 30 Radek Antoniuk 2016-12-02 06:59:13 EST
Any news on this guys?
Comment 31 Pranith Kumar K 2016-12-02 08:53:37 EST
(In reply to Radek Antoniuk from comment #30)
> Any news on this guys?

hi,
   We discussed about this in the last gluster summit. There are two solutions one from Facebook guys and the other from the guys in Redhat. Both of them have different plus points. We need to finalize on the best parts from both of these solutions and implement it.

Pranith

Note You need to log in before you can comment on or make changes to this bug.